<?php
/**
*
* @package fs
* @author : Copyright 2007 TheUniqueTiger and copyright 2009 phpbb3-mods.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* fs_basic
* Displays basic statistics - submodules : basic, advanced
*
* @package fs
*/
class fs_basic
{
	var $u_action;

	function main($id, $mode)
	{
		global $config, $db, $user, $auth, $template, $phpbb_root_path, $phpEx;
		global $cache;
		
		switch ($mode)
		{
			case 'basic':
				//get and display the basic statistics
				$template_count = 0;
				$limit_count = request_var('limit_count', 10); //replace 10 by the config option

				//create an array containing the limit_count options as $option=>$option_lang
				$limit_options = array(
					'1'		=> 1,
					'3'		=> 3,
					'5'		=> 5,
					'10'	=> 10,
					'15'	=> 15,
				);
				$limit_prompt = sprintf($user->lang['LIMIT_PROMPT'], $user->lang['SMILEY']);
				$total_posts = $config['num_posts'];
				$total_topics = $config['num_topics'];
				$total_users = $config['num_users'];
				$total_attachments = $config['num_files'];
				// get smiley statistics
				$smiley_counter = get_smilies_forum_data();
				$smiley_display_on_posts = get_smilies_forum_data('display_on_posting');
                // get icon stats
                $icons_counter = get_icons_onboard_data();
				$icons_display_on_posts = get_icons_onboard_data('display_on_posting');
			    //get board age
				$boarddays = (time() - $config['board_startdate']) / 86400;				
				
				$forum_counts = get_forum_count();				
				$total_polls = get_polls_count();
				
				$topic_types_count = get_topic_types_count();
				
				$users_count_data = get_user_count_data();
                $report_count_total = report_count_total();
                $report_count_open = report_count_open();
                $report_count_closed = report_count_closed();
                $banned_users_total = banned_users();
                $bookmarked_topic_count_total = bookmarked_topics();
                $subscribed_topic_count_total = subscribed_topics();
                $subscribed_forum_count_total = subscribed_forums();
				$template->assign_vars(array(
					'TOTAL_POSTS'					=> $total_posts,
					'TOTAL_TOPICS'					=> $total_topics,
					'TOTAL_USERS'					=> $total_users,
					'TOTAL_FORUM_CAT'			=> $forum_counts[FORUM_CAT],
					'TOTAL_FORUM_POST'		=> $forum_counts[FORUM_POST],
					'TOTAL_FORUM_LINK'		=> $forum_counts[FORUM_LINK],
					'TOTAL_FORUMS'			=> array_sum($forum_counts),
					'TOTAL_ATTACHMENTS'		=> $total_attachments,
					'TOTAL_POLLS'			=> $total_polls,
					'TOPIC_TYPES_GLOBAL'	=> $topic_types_count['global'],
					'TOPIC_TYPES_ANNOUNCE'  => $topic_types_count['announce'],
					'TOPIC_TYPES_STICKY'		=> $topic_types_count['sticky'],
					'TOPIC_TYPES_NORMAL'		=> $topic_types_count['normal'],
					'TOPIC_TYPES_UNAPPROVED'	=> $topic_types_count['unapproved'],
					'UNAPPROVED_POSTS'		=> $topic_types_count['unapproved_posts'],
					'USERS_INACTIVE'		=> $users_count_data['inactive'],
					'USERS_ACTIVE'			=> $users_count_data['active'],
					'USERS_ACTIVE_EXPLAIN'	=> sprintf($user->lang['USERS_ACTIVE_EXPLAIN'], 30), //replace 30 by configurable number if you wish
					'USERS_INACTIVE_EXPLAIN'	=> sprintf($user->lang['USERS_INACTIVE_EXPLAIN'], 30), //same comment as above
					'TOTAL_BOTS'			=> $users_count_data['registered_bots'],
					'VISITED_BOTS'			=> $users_count_data['visited_bots'],
					'AVG_POSTS_PER_DAY'		=> sprintf('%.2f', $total_posts / $boarddays),
					'AVG_TOPICS_PER_DAY'	=> sprintf('%.2f', $total_topics / $boarddays),
					'AVG_USERS_PER_DAY'	=> sprintf('%.2f', $total_users / $boarddays),
					'AVG_FILES_PER_DAY'		=> sprintf('%.2f', $total_attachments / $boarddays),
					'MOST_ONLINE'			=> $config['record_online_users'],
					'MOST_ONLINE_DATE'		=> $user->format_date($config['record_online_date']),
					'TOTAL_BOARD_SMILEY_COUNT' 		=> $smiley_counter,
					'DISPLAY_SMILIES_ON_POSTING_COUNT'	=> ($smiley_counter) ? $smiley_display_on_posts . ' / ' . $smiley_counter .  ' (' . number_format($smiley_display_on_posts / $smiley_counter * 100, 3) . '%)' : ' 0 / 0',
					'TOP_SMILIES_BY_URL'		=> sprintf($user->lang['TOP_SMILIES_BY_URL'], $limit_count),
					'TOTAL_BOARD_ICONS_COUNT' 		=> $icons_counter,
					'DISPLAY_ICONS_ON_POSTING_COUNT'	=> ($icons_counter) ? $icons_display_on_posts . ' / ' . $icons_counter .  ' (' . number_format($icons_display_on_posts / $icons_counter * 100, 3) . '%)' : ' 0 / 0',
					'TOP_ICONS_BY_URL'		=> sprintf($user->lang['TOP_ICONS_BY_URL'], $limit_count),
                    'TOTAL_REPORTS'         => $report_count_total,
                    'REPORTED_PERCENT'         =>   ($report_count_total) ? $report_count_total . ' / ' . $total_posts .  ' (' . number_format($report_count_total / $total_posts * 100, 3) . '%)' : ' 0 / 0',
                    'TOTAL_REPORTS_OPEN'    => $report_count_open,
                    'TOTAL_REPORTS_CLOSED'  => $report_count_closed,
                    'BANNED_USERS_TOTAL' => $banned_users_total,
                    'BANNED_PERCENT'    =>  ($banned_users_total) ? $banned_users_total . ' / ' . $total_users .  ' (' . number_format($banned_users_total / $total_users * 100, 3) . '%)' : ' 0 / 0',
                    'TOTAL_BOOKMARKS'   =>  $bookmarked_topic_count_total,
                    'TOTAL_SUBSCRIBED_T'  => $subscribed_topic_count_total,
                    'TOTAL_SUBSCRIBED_F'  => $subscribed_forum_count_total,
					));
				
			break;
			
			case 'advanced':
				//get and display advanced statistics
				include ("{$phpbb_root_path}includes/functions_admin.$phpEx"); //for database size

				//get avatars info .. code taken from phpBB3 acp_main
				$avatars = array(
					'total_files'			=> 0,
					'total_size'			=> 0,
				);
				if ($avatar_dir = @opendir($phpbb_root_path . $config['avatar_path']))
				{
					while (($file = readdir($avatar_dir)) !== false)
					{
						if ($file[0] != '.' && $file != 'CVS' && strpos($file, 'index.') === false)
						{
							$avatars['total_size'] += filesize($phpbb_root_path . $config['avatar_path'] . '/' . $file);
							$avatars['total_files']++;
						}
					}
					@closedir($avatar_dir);
				}
				//get cached files data ... code similar to the above code for avatars
				$cached_files = array(
					'total_files'			=> 0,
					'total_size'			=> 0,
				);
				$cache_path = 'cache';
				if ($cache_dir = @opendir($phpbb_root_path . $cache_path))
				{
					while (($file = readdir($cache_dir)) !== false)
					{
						if ($file[0] != '.' && $file != 'CVS' && strpos($file, 'index.') === false)
						{
							$cached_files['total_size'] += filesize($phpbb_root_path . $cache_path . '/' . $file);
							$cached_files['total_files']++;
						}
					}
					@closedir($cache_dir);
				}
				
				//get info about installed components
				$inst_comps = $cache->obtain_installed_components();				
				//styles
				foreach ($inst_comps['styles'] as $row)
				{						
					$template->assign_block_vars('stylerow', array(
					'STYLE_NAME'			=> $row['style_name'],
					'STYLE_COPYRIGHT'			=> $row['style_copyright'],
					));
				}				
				//imagesets				
				foreach ($inst_comps['imagesets'] as $row)
				{
					$template->assign_block_vars('imagesetrow', array(
						'IMAGESET_NAME'			=> $row['imageset_name'],
						'IMAGESET_COPYRIGHT'			=> $row['imageset_copyright'],
					));
				}				
				//templates				
				foreach ($inst_comps['templates'] as $row)
				{
					$template->assign_block_vars('templaterow', array(
						'TEMPLATE_NAME'			=> $row['template_name'],
						'TEMPLATE_COPYRIGHT'			=> $row['template_copyright'],
					));
				}
				//themes				
				foreach ($inst_comps['themes'] as $row)
				{
					$template->assign_block_vars('themerow', array(
						'THEME_NAME'			=> $row['theme_name'],
						'THEME_COPYRIGHT'			=> $row['theme_copyright'],
					));
				}				
				//lang packs				
				foreach ($inst_comps['lang_packs'] as $row)
				{
					$template->assign_block_vars('langrow', array(
						'LANG_NAME'			=> $row['lang_local_name'],
						'LANG_ISO'			=> $row['lang_iso'],
						'LANG_AUTHOR'		=> $row['lang_author'],
					));
				}
				
				$template->assign_vars(array(
					'START_DATE'					=> $user->format_date($config['board_startdate']),
					'BOARD_AGE'						=> get_time_string($config['board_startdate']),
					'BOARD_VERSION'					=> $config['version'],
					'GZIP_COMPRESSION'				=> ($config['gzip_compress']) ? $user->lang['ON'] : $user->lang['OFF'],
					'DATABASE_INFO'				=> $db->sql_server_info(),
					'DATABASE_SIZE'				=> get_database_size(),
					'ATTACHMENTS_TOTAL'		=> $config['num_files'],
					'ATTACHMENTS_SIZE'			=> get_formatted_filesize_fs($config['upload_dir_size']),
					'AVATARS_TOTAL'		=> $avatars['total_files'],
					'AVATARS_SIZE'			=> get_formatted_filesize_fs($avatars['total_size']),
					'CACHED_FILES_TOTAL'	=> $cached_files['total_files'],
					'CACHED_FILES_SIZE'		=> get_formatted_filesize_fs($cached_files['total_size']),
					'S_STYLES'				=> (sizeof($inst_comps['styles'])) ? true : false,
					'S_IMAGESETS'			=> (sizeof($inst_comps['imagesets'])) ? true : false,
					'S_TEMPLATES'			=> (sizeof($inst_comps['templates'])) ? true : false,
					'S_THEMES'				=> (sizeof($inst_comps['themes'])) ? true : false,
					'S_LANG_PACKS'			=> (sizeof($inst_comps['lang_packs'])) ? true : false,
				));

				break;


			default:
		}
		
		$template->assign_vars(array(
			'L_TITLE'	=> $user->lang['FS_BASIC_' . strtoupper($mode)],			
			'S_FS_ACTION'		=> $this->u_action,
			'AS_ON'				=> sprintf($user->lang['AS_ON'], $user->format_date(time())),
		));
		
		$this->tpl_name = 'fs_basic_' . $mode;
		$this->page_title = $user->lang['STATISTICS'] . ' &bull; ' . $user->lang[strtoupper($this->tpl_name)];
		
	}
}
?>